//* means removed for security

#include <fxlib.h>
#include "save.h"

FONTCHARACTER filename[] = {'\\','\\','f','l','s','0','\\','B','D','u','d','e','.','s','a','v',0};

int saveRead(char *c, int size) {
	int file;
	file = Bfile_OpenFile(filename, _OPENMODE_READ);
	if(file >= 0) {
		Bfile_ReadFile(file, c, size, 0);
		Bfile_CloseFile(file);
		return 1;
	}
	else return 0;
}

void saveWrite(char *c, int size) {
	int file;
	Bfile_DeleteFile(filename);
	Bfile_CreateFile(filename, size);
	file = Bfile_OpenFile(filename, _OPENMODE_WRITE);
	if(file >= 0) {
		Bfile_WriteFile(file, c, size);
		Bfile_CloseFile(file);
	}
}

void encrypt(int n) {
	char words[12][3] = {"***", "***", "***", "***", "***", "***", "***", "***", "***", "***", "***", "***"};
	char wordCrypted[3];
	char rot1[26], rot2[26];
	int i;
	
	initRot(&rot1, &rot2);
	for(i = 0 ; i < 3 ; i++) wordCrypted[i] = rot2[(rot1[(words[n][i] - 65 + i) % 26] - 65 + i) % 26];
	saveWrite(&wordCrypted, 3);
}

int decrypt(void) {
	char words[12][3] = {"***", "***", "***", "***", "***", "***", "***", "***", "***", "***", "***", "***"};
	char wordCrypted[3], wordDecrypted[3];
	char table[26] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	char rot1[26], rot2[26];
	int i, j, k;
	
	initRot(&rot1, &rot2);
	i = saveRead(&wordCrypted, 3);
	if(i) {
		for(i = 0 ; i < 3 ; i++) {
			j = 0;
			while(wordCrypted[i] != rot2[j]) j++;
			k = 0;
			while(table[(j - i + 26) % 26] != rot1[k]) k++;
			wordDecrypted[i] = table[(k - i + 26) % 26];
		}
		
		for(i = 0 ; i < 12 ; i++) {
			k = 0;
			for(j = 0 ; j < 3 ; j++) {
				if(wordDecrypted[j] == words[i][j]) k++;
			}
			if(k == 3) return i;
		}
	}
	return 0;
}

void getOne(char *n) {
    int i, j = 0;
    char c, *ptr = (char *)0x8000FFD0;
	
    for(i = 0 ; i < 8 ; i++) {
        c = *(ptr+i);
		if(c >= 65 && c <= 90) n[j++] = c;
    }
	for(j ; j < 8 ; j++) n[j] = 65 + j;
}

void initRot(char *rot1, char *rot2) {
	int i, j;
	char init[8], seq1[26] = "**************************", seq2[26] = "**************************";
	
	getOne(&init);
	i = 0;
	while(seq1[i] != init[0]) i++;
	for(j = 0 ; j < 26 ; j++) rot1[j] = seq1[(i + j) % 26];
	i = 0;
	while(seq2[i] != init[1]) i++;
	for(j = 0 ; j < 26 ; j++) rot2[j] = seq2[(i + j) % 26];
}